import x10.io.Console; 
import x10.util.Random;
import x10.util.ArrayList;

public class Reduction {

    static val rand:Random = new Random(System.nanoTime());
    val a = new ArrayList[Int]();   
    var total:Int=0;

    def this(n:Int){
	for (var i:Int=0;i<n;i++){
	    a.add(rand.nextInt(10));
	}
    }

    def perform() {
        val n:Int = Math.nextPowerOf2(a.size());
        for(var i:Int=a.size();i<n;i++)
	    a.add(0);

	var i:Int = 0;
	for(var step:Int=n/2;step>=1;step=step/2){	
            Console.OUT.println(step);
	    finish {           
	        for(i=0;i<step;i++) {
                    val k = i;
 		    async a(k) += a(k+step);                
                }
            }
        }
        total = a(0);
        
    }    

    public static def main(args:Rail[String]){
	if (args.size<1){
	    Console.OUT.println("Usage: Reduction <n>");
	    return;	
	}

	val n = Int.parseInt(args(0));
	val red = new Reduction(n);
        for (var i:Int=0;i<n;i++){
	    Console.OUT.print(red.a(i)+" ");
	}
	Console.OUT.println();
	red.perform();

        Console.OUT.println("Sum: "+red.total);
    }

}
